<template>
	<xn-form-container
		:title="formData.id ? '编辑蛋糕券' : '增加蛋糕券'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" :label-col="{span: 5}">
			<a-form-item label="蛋糕券：" name="couponAmount">
				<a-input-number v-model:value="formData.couponAmount" style="width: 100%" :min="0" :max="99999999"
								:precision="2" placeholder="请输入蛋糕券" allow-clear/>
			</a-form-item>
			<a-form-item label="蛋糕券类型：" name="couponType">
				<a-radio-group button-style="solid" v-model:value="formData.couponType">
					<a-radio-button value="1">
						寸
					</a-radio-button>
					<a-radio-button value="2">
						元
					</a-radio-button>
				</a-radio-group>
			</a-form-item>
			<a-form-item label="蛋糕券数量：" name="couponNum">
				<a-input-number v-model:value="formData.couponNum" style="width: 100%" :min="0" :max="99999999"
								:precision="0" placeholder="请输入蛋糕券数量" allow-clear/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="couponConfigForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import couponConfigApi from '@/api/biz/couponConfigApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (planId,record) => {
		console.log("planID:"+planId)
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}else{
			formData.value.couponType = '1'
			formData.value.rechargePlanId = planId
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		couponAmount: [required('请输入蛋糕券')],
		couponType: [required('请选择蛋糕券类型')],
		couponNum: [required('请输入蛋糕券数量')],
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				couponConfigApi
					.couponConfigSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
